# Filters added to this controller will be run for all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

require 'datenbank'

class ApplicationController < ActionController::Base

  layout      "firstrails"
  
  include Treelist_Modul    # muss auf Klassenebene integriert werden          
  helper_method             :treelist_show
    
  # <b>initialize</b> initialisiert die Layout-Vorgaben
  
  def initialize
    @css          = "stylesheet_link_tag 'main'"
    @logo         = "image_tag(\"bussole-LogoUndWortmarke.gif\", :alt => \"bussole Logo\", :size => \"390x50\")"
    @title        = "Dateiinformationen"
    view_database
  end
  
  # <b>index</b> - Standardanzeige
#  
  def index
    #view_database  
  end

  # <b>test</b> dient nur zum Test, auch der Dokumentation: (#database), List, list

  def test
   view_database
   
   @info = "hinweis"
   flash[:notice] = __FILE__, '  <i>= aktuelle Source</i><br><br>', 
                      RAILS_ROOT, '   <i>= Rails-Konfiguration</i><br><br>',  
                      ABSOLUTE_RAILS_ROOT, '   <i>= absoluter Pfad</i><br><br>',
                      RAILS_ENV, '   <i>= Umgebung</i><br><br>', 
                      RAILS_CONNECTION_ADAPTERS, '   <i>= Datenbanktypen</i><br><br>', 
                      Dateis.active_connection_name, '   <i>= aktive Verbindungen</i><br><br>',
                      Dateis.connection.tables, '   <i>=  alle Dateien der angebundenen Datenbank</i><br><br>',
                      " " , Dateis.__id__, "  = Klassenvariable __id__"
      
    render :action => 'index'
  end   
  def test1
    render :inline => "<%= 'hello, ' * 3 + 'again' %>" 
  end  
  def test_1z
    #@info = "hinweis"
    @info = "error" 
    flash[:notice] = "gerade mal eine einzige Zeile"
    render :action => 'index'
  end
       
  # <b>database</b> fordert die bersicht der Datenbanken sowie ggf. ihre Aktualisierung an
      
  def database
    view_database(params[:conn], params[:update])
    if params[:update]
      render :partial => "application/treelist", :locals => { :name => @view_name}
    else
      render :action => 'index'
    end
   end

 ######################################################################################################   
   
   private
   
   # <b>view_database</b> bereitet das angeforderte Datenbankobjekt auf
    
    def view_database(*parms)
      parms[0]  = "prv"       if parms.length == 0
      clear       = parms[2] ? parms[2] : "" 
      @data       = Datenbank.new(parms[0], parms[1])      
      @database   = @data.data
      @info       = @data.info
      @view_name  = @data.view_name                  # aktuelle Sicht
      
      trees_and_partials(@view_name, @data.treelist, @data.treelist_header, clear)
      flash[:notice] = @data.notice if @params       # flash wird nur ausgegeben, falls @notice nicht leer ist / @params wegen Initialisierung  
    end
       
end