
require 'treelist'

# <b>Treelist_Modul</b> stellt die Schnittstelle zwischen Treelist-Objekten und dem Controller dar
# @default setzt dabei den Unterlassungswert fr die Treelist - ob sie anfangs auf- und zugeklappt ist 
#
# auftretende Fehler werden dabei als Programmierfehler betrachtet: keine Ausgabe ber @notice

module Treelist_Modul

  attr_accessor :tree_html

 # <b>tree_response</b> nimmt die Anforderungen vom Browser entgegen und verteilt sie
  
  def tree_response
    trees_and_partials(params[:html_name])  unless defined?(@@trees)
    
    tree          = @@trees.fetch(params[:html_name])  
    tree.do_html(params[:html_id])
    render :partial  => "application/treelist", :locals => { :name => params[:html_name]} 
     
  end

 # <b>treelist_show</b> ermittelt die anzuzeigende Baumstruktur

  def treelist_show(partial)    

    if @@trees.key?(partial)       
      @tree_html                  = @@trees.fetch(partial).tree_html      
    else
      raise "Fehler in #{File.basename(__FILE__)}, #{__LINE__}: \"#{partial}\" ist kein gueltiges Partial"
    end 

  end
 
 ######################################################################################################   
   
  private
  
  # <b>trees_and_partials</b> speichert die Zuordnung der Treelist zum Partial ab
  
  def trees_and_partials(partial, treelist, treelist_header, clear)
    @default          = '-1'          # Baum soll aufgeklappt sein
    @@trees           = {}            unless defined?(@@trees)    
    @@trees.delete(partial)           unless clear.empty?
    unless @@trees.key?(partial)
      @@trees[partial]  = Treelist.new(partial, treelist, treelist_header, @default)
    end
  end
   
end     # module
